import Data.List (lookup)
import System.Environment (getArgs)
import Control.Monad (forever)
import Database

extractMiddleName :: String -> Maybe String
extractMiddleName givenName = 
	case words givenName of
		(_:m:_) -> Just m
		_ -> Nothing

getMiddleName :: String -> Maybe String
getMiddleName surname = do
	givenName <- lookup surname database
	middleName <- extractMiddleName givenName
	return middleName

app :: IO ()
app = do
	putStrLn "What's the surname?"
	surname <- getLine
	case getMiddleName surname of
		Nothing -> putStrLn "not found"
		Just x -> putStrLn $ "middle name is " ++ x
	return ()

main :: IO ()
main = do
	forever app
	return ()
