import Prelude hiding (lookup, Maybe, Just, Nothing)
import Database

data Maybe a = Nothing | Just a

getMiddleName :: String -> Maybe String
getMiddleName surname = 
	case lookup surname database of
		Nothing -> Nothing
		Just givenName ->
			case extractMiddleName givenName of
				Nothing -> Nothing
				Just middleName -> Just middleName
					
lookup :: String -> [(String, String)] -> Maybe String
lookup _ [] = Nothing
lookup key ((key',value):tail)
	| key == key' = Just value
	| otherwise = lookup key tail

extractMiddleName :: String -> Maybe String
extractMiddleName givenName = 
	case words givenName of
		(_:m:_) -> Just m
		_ -> Nothing

app :: String -> String
app surname = case getMiddleName surname of
	Just w -> w
	Nothing -> "<<not found>>"

main = interact $ unlines.(map app).lines
